Summary: Bidirectional data relay between two data channels ('netcat++')
Name: socat
Version: 1.7.3.2
Release: 1
License: GPLv2
URL:  http://www.dest-unreach.org/%{name}
Source0: http://www.dest-unreach.org/socat/download/%{name}-%{version}.tar.bz2
Patch0: %{name}-%{version}-aix.patch
Group: Applications/Internet

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: patch >= 2.5.4-4
BuildRequires: gcc >= 4.5.4-1
BuildRequires: readline-devel >= 7.0-3

Requires: bash  >= 4.3.30-1
Requires: readline >= 7.0-3

%description
Socat is a relay for bidirectional data transfer between two independent data
channels. Each of these data channels may be a file, pipe, device (serial line
etc. or a pseudo terminal), a socket (UNIX, IP4, IP6 - raw, UDP, TCP), an
SSL socket, proxy CONNECT connection, a file descriptor (stdin etc.), the GNU
line editor (readline), a program, or a combination of two of these.


%prep
%setup -q
%patch0

mkdir ../32bit
mv  * ../32bit
mv ../32bit .
mkdir 64bit
cp -r 32bit/* 64bit

%build
      export CFLAGS="-DSYSV -D_AIX -D_AIX32 -D_AIX41 -D_AIX43 -D_AIX51 -D_ALL_SOURCE -DFUNCPROTO=15 -O -I/opt/freeware/include"
cd 64bit
export OBJECT_MODE=64
#export CC="/usr/vac/bin/xlc_r -q64"
export CC="/opt/freeware/bin/gcc  -maix64 -O2"
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib "
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-help \
    --enable-stdio \
    --enable-fdnum \
    --enable-file \
    --enable-creat \
    --enable-gopen \
    --enable-pipe \
    --enable-termios \
    --enable-unix \
    --enable-ip4 --enable-ip6 \
    --enable-rawip \
    --enable-tcp --enable-udp \
    --enable-listen \
    --enable-proxy \
    --enable-exec \
    --enable-system \
    --enable-pty \
    --enable-readline \
    --enable-openssl \
    --enable-sycls \
    --enable-filan \
    --enable-retry \
    --enable-libwrap \
    --enable-fips
gmake %{?_smp_mflags}
if [ "%{dotests}" == 1 ]
      then
          (gmake -k check || true)
      fi
     
     
      cd ../32bit
      export OBJECT_MODE=32
     export CC="/opt/freeware/bin/gcc  -maix32 -O2   -D_LARGE_FILES"
      export LDFLAGS="-Wl,-bmaxdata:0x80000000"
     
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-help \
    --enable-stdio \
    --enable-fdnum \
    --enable-file \
    --enable-creat \
    --enable-gopen \
    --enable-pipe \
    --enable-termios \
    --enable-unix \
    --enable-ip4 --enable-ip6 \
    --enable-rawip \
    --enable-tcp --enable-udp \
    --enable-listen \
    --enable-proxy \
    --enable-exec \
    --enable-system \
    --enable-pty \
    --enable-readline \
    --enable-openssl \
    --enable-sycls \
    --enable-filan \
    --enable-retry \
    --enable-libwrap \
    --enable-fips

gmake %{?_smp_mflags}     
if [ "%{dotests}" == 1 ]
      then
          (gmake -k check || true)
      fi

%install
#[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
#make DESTDIR=${RPM_BUILD_ROOT} install

#/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

cd 64bit
      export OBJECT_MODE=64
      export AR="/usr/bin/ar -X64"
          gmake DESTDIR=${RPM_BUILD_ROOT} install
#           /usr/bin/strip ${RPM_BUILD_ROOT}%{_sbindir}/* || :
 /usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :
          (
             cd ${RPM_BUILD_ROOT}%{_bindir}
            for f in $(ls -1| grep -v -e _32 -e _64)
            do
              mv ${f} ${f}_64
            done
         )
    
     cd ../32bit
     export OBJECT_MODE=32
     export AR="/usr/bin/ar -X32"
         gmake DESTDIR=${RPM_BUILD_ROOT} install
          /usr/bin/strip ${RPM_BUILD_ROOT}%{_bindir}/* || :
         (
            cd ${RPM_BUILD_ROOT}%{_bindir}
            for f in $(ls -1| grep -v -e _32 -e _64)
          do
            mv ${f} ${f}_32
             ln -sf ${f}_64 ${f}
           done
          )

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system)
%doc 32bit/BUGREPORTS 32bit/CHANGES 32bit/DEVELOPMENT 32bit/EXAMPLES 32bit/FAQ 32bit/PORTING
%doc 32bit/COPYING* 32bit/README 32bit/SECURITY 
%doc 32bit/daemon.sh 32bit/ftp.sh 32bit/gatherinfo.sh 32bit/mail.sh 32bit/proxy.sh
%doc 32bit/proxyecho.sh 32bit/readline.sh 32bit/readline-test.sh
%doc 32bit/socks4echo.sh 32bit/socks4a-echo.sh 32bit/test.sh
%{_bindir}/*
%{_mandir}/man1/*


%changelog
* Fri Nov 09 2018 Harshita Jain <harjain9@in.ibm.com> - 1.7.3.2-1
- Updated to version 1.7.3.2-1

* Wed Jun 13 2018 Michael Perzl <michael@perzl.org> - 1.7.3.2-1
- updated to version 1.7.3.2

* Wed Nov 16 2016 Michael Perzl <michael@perzl.org> - 1.7.3.1-2
- recompiled against latest versions

* Mon May 02 2016 Michael Perzl <michael@perzl.org> - 1.7.3.1-1
- updated to version 1.7.3.1

* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 1.7.3.0-2
- recompiled against latest version of openssl

* Thu Apr 02 2015 Michael Perzl <michael@perzl.org> - 1.7.3.0-1
- updated to version 1.7.3.0

* Mon Mar 10 2014 Michael Perzl <michael@perzl.org> - 1.7.2.4-1
- updated to version 1.7.2.4

* Wed Jan 29 2014 Michael Perzl <michael@perzl.org> - 1.7.2.3-1
- updated to version 1.7.2.3

* Fri Jun 21 2013 Michael Perzl <michael@perzl.org> - 1.7.2.2-1
- first version for AIX V5.1 and higher


